/***********************************************************************/
/*                                                                     */
/*       (c) Copyright 2010                                           */
/*       All rights reserved                                           */
/*                                                                     */
/*       Programs written by Michael Bao                            */
/*       Department of Computer Science                                */
/*       New Jersey Institute of Technology                            */
/*       University Heights, Newark, NJ 07102, USA                     */
/*       In the group of Jason T. L. Wang (NJIT)                */
/*                                                                     */
/*	 Permission to use, copy, modify, and distribute this	       */
/*	 software and its documentation for any purpose and without    */
/*	 fee is hereby granted, provided that this copyright	       */
/*	 notice appears in all copies.   Programmer(s) makes no	       */
/*	 representations about the suitability of this		       */
/*	 software for any purpose.  It is provided "as is" without     */
/*	 express or implied warranty.				       */
/*                                                                     */
/***********************************************************************/

#ifndef KMERPROB_H_
#define KMERPROB_H_

#include<iostream>
#include<fstream>
#include<vector>
#include<map>
#include<stdlib.h>
#define K_SIZE	5
#define K_POSSIB pow((float)4, (int)K_SIZE)

using namespace std;

struct subsequence
{
	int begin;
	int end;
	string name;
	int hash;
};



class KmerProb {
public:
	KmerProb(string input, string genome, string KnownRNA, bool override = false);
	virtual ~KmerProb();

	int H(char* string);

	void InitiateFrequencies(map<int,int>, map<int,int>);
	void open();
	void CalculateKnownNcRnaHash();
	double getLogSingleSequence();

	int id;

private:
	ifstream GenomeFile;
	ifstream KnownRnaFile;
	string strGenomeFile;
	string strKnownRnaFile;

	bool bGotGenome;

	string RNASequence;
	string GenomeSequence;

	int GenomeSize;
	int GenomeKmerCount;

	vector<subsequence> KnownNcRna;
	map<int, int> GenomeFrequency;
	map<int, int> RNAFrequency;

	bool bOverride;
	bool bGotFrequencies;



};

#endif /* KMERPROB_H_ */
