/***********************************************************************/
/*                                                                     */
/*       (c) Copyright 2010                                           */
/*       All rights reserved                                           */
/*                                                                     */
/*       Programs written by Michael Bao                            */
/*       Department of Computer Science                                */
/*       New Jersey Institute of Technology                            */
/*       University Heights, Newark, NJ 07102, USA                     */
/*       In the group of Jason T. L. Wang (NJIT)                */
/*                                                                     */
/*	 Permission to use, copy, modify, and distribute this	       */
/*	 software and its documentation for any purpose and without    */
/*	 fee is hereby granted, provided that this copyright	       */
/*	 notice appears in all copies.   Programmer(s) makes no	       */
/*	 representations about the suitability of this		       */
/*	 software for any purpose.  It is provided "as is" without     */
/*	 express or implied warranty.				       */
/*                                                                     */
/***********************************************************************/

#ifndef LINREG_H_
#define LINREG_H_

#include <iostream>
#include <fstream>
#include <vector>
#include <math.h>

struct LinearPoint
{
	float x;
	float y;
};

using namespace std;

class LinReg {
public:
	LinReg();
	virtual ~LinReg();

	void InitModel(string);
	void InitModel(vector<LinearPoint>, bool b = true, string o = "");
	float GetValue(float);

private:

	vector<LinearPoint> Points;

	float slope;
	float intercept;
};

#endif /* LINREG_H_ */
