/***********************************************************************/
/*                                                                     */
/*       (c) Copyright 2010                                           */
/*       All rights reserved                                           */
/*                                                                     */
/*       Programs written by Michael Bao                            */
/*       Department of Computer Science                                */
/*       New Jersey Institute of Technology                            */
/*       University Heights, Newark, NJ 07102, USA                     */
/*       In the group of Jason T. L. Wang (NJIT)                */
/*                                                                     */
/*	 Permission to use, copy, modify, and distribute this	       */
/*	 software and its documentation for any purpose and without    */
/*	 fee is hereby granted, provided that this copyright	       */
/*	 notice appears in all copies.   Programmer(s) makes no	       */
/*	 representations about the suitability of this		       */
/*	 software for any purpose.  It is provided "as is" without     */
/*	 express or implied warranty.				       */
/*                                                                     */
/***********************************************************************/

#ifndef SVMREGRESSION_H_
#define SVMREGRESSION_H_

#include "svm.h"
#include "RNASeq.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <fstream>
#define MODEL_FILE "MeanRegression.model"
#define STDDEV_MODEL_FILE "StdDevRegression.model"
#define TOTAL_SAMPLES 15
#define SAMPLE_MFE_SIZE 250

class SVMRegression {
public:
	SVMRegression();
	virtual ~SVMRegression();

	int TrainSVM();
	double PredictMean(int);
	double PredictSD(int);

private:
	svm_model* MeanMod;
	svm_model* SdMod;

	string RandomSequence(int, double);
	double CrossValidation(svm_problem& prob, svm_parameter& param);
};

#endif /* SVMREGRESSION_H_ */
